<?php
/**
* Loudtalks Mesh API sandbox 
* 
* 
*/
require("./services_json.class.php"); // JSON helper class
require("./loudtalks_api.class.php"); // Loudtalks Mesh API wrapper

$host = "testing.cloud.net";	// your Loudtalks Mesh or Loudtalks Cloud hostname
$apikey = "0DSCXNHMLV902BYKXPWOB7ZDTKJ3H0DT"; // your API key

$ltapi = new LoudtalksServerAPI($host, $apikey);
if (!$ltapi) {
	die("Failed to create API wrapper instance");
}

// See if we "preserved" Session ID through GET parameter. Use it if we did
$sid = isset($_GET["sid"]) ? $_GET["sid"] : '';
if ($sid) {
	$ltapi->sid = $sid;
	echo("Session ID was provided, use it and skip login authentication. ");
	echo('Session ID is <a href="?sid='.$ltapi->sid.'">'.$ltapi->sid.'</a>');
// No Session ID -- authenticate using username / password
} else {
	if (!$ltapi->auth("admin", "nevermind")) {
		echo("auth error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
		echo("<br/>request: ".$ltapi->lastUrl);
	} else {
		echo('auth successful. Session ID is <a href="?sid='.$ltapi->sid.'">'.$ltapi->sid.'</a>');
	}
}

if (!$ltapi->getUsers()) {
	echo("<br/>getUsers error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
	echo("<br/>request: ".$ltapi->lastUrl);
} else {
	echo("<br/>Users list:");
	arrayOut($ltapi->data["users"]);
}

if (!$ltapi->getChannels()) {
	echo("<br/>getChannels error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
	echo("<br/>request: ".$ltapi->lastUrl);
} else {
	echo("<br/>Channels list:");
	arrayOut($ltapi->data["channels"]);
}
//phpinfo();

// Add or update user
if (!$ltapi->saveUser(array(
	"name" => "ltapi_test",
	"password" => md5("test"),
	"email" => "support@loudtalks.com",
	"full_name" => "API Test 'На здоровье'", // UTF-8 is fully supported 
	"job" => "API guinea pig"
))) {
	echo("<br/>saveUser error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
	echo("<br/>request: ".$ltapi->lastUrl);
} else {
	echo("<br/>User added or updated");
}

// List users again -- look the new user is there
if (!$ltapi->getUsers()) {
	echo("<br/>getUsers error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
	echo("<br/>request: ".$ltapi->lastUrl);
} else {
	echo("<br/>Users list:");
	arrayOut($ltapi->data["users"]);
}

// Delete the user we just added
if (!$ltapi->deleteUsers(array("ltapi_test"))) {
	echo("<br/>deleteUsers error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
	echo("<br/>request: ".$ltapi->lastUrl);
} else {
	echo("<br/>Users removed");
}

// List users one last time -- the new user is gone
if (!$ltapi->getUsers()) {
	echo("<br/>getUsers error: ".$ltapi->errorCode." ".$ltapi->errorDescription);
	echo("<br/>request: ".$ltapi->lastUrl);
} else {
	echo("<br/>Users list:");
	arrayOut($ltapi->data["users"]);
}

/*
 * A simple helper function to aid data output in this example 
 */
function arrayOut($arr) {
	echo '<table border="1">';
	echo "<tr><td>".implode("</td><td>", array_keys($arr[0]))."</td></tr>";
	foreach ($arr as $row) {
		echo "<tr><td>".implode("</td><td>", array_map("printValue", $row))."</td></tr>";
	}
	echo "</table>";
}
function printValue($val){
	if (is_array($val)) {
		return implode(", ", $val);
	} else {
		return $val;
	}
}

?>